/*
 * dataheap_misc.h
 *
 *  Created on: 22.02.2009
 *      Author: mkluge
 */

#ifndef _HAVE_DATAHEAPMISC_H_
#define _HAVE_DATAHEAPMISC_H_

typedef enum {COUNTER_TYPE_MOMENT,COUNTER_TYPE_INTEGRAL,COUNTER_TYPE_STATIC} COUNTER_TYPE;

#ifdef __cplusplus

#include <vector>
#include <string>
#include <list>
#include <map>
#include <QMutex>

using namespace std;

/* a list of strings */
typedef list<string>        StringList;
/* a list of integers  */
typedef list<int>           IntList;
/* a hash map of strings for strings */
typedef map<string,string> StringMap;

extern QMutex logMutex;
#define logEntry(...) {logMutex.lock(); fprintf( stderr, "%p: ", (void*)QThread::currentThread()); fprintf( stderr, __VA_ARGS__); fflush(stderr); logMutex.unlock();}

#endif

typedef enum
{
    DATA_TYPE_UINT64,
    DATA_TYPE_DOUBLE,
} DataType;

/** a type to pack a list of strings
 */
typedef struct string_list_t
{
    char** data;
    int    count;
} string_list;


#endif /* _HAVE_DATAHEAPMISC_H_ */
